//+------------------------------------------------------------------+
//| Color Candles cross Kijun Sen :  2013  file45                   |
//+------------------------------------------------------------------+
#property indicator_chart_window

#property indicator_buffers 8
#property indicator_color1 CornflowerBlue // Shadows - long up
#property indicator_color2 RoyalBlue // Shadows - long down
#property indicator_color3 CornflowerBlue // Bodies - long up
#property indicator_color4 RoyalBlue // Bodies - long down
#property indicator_color5 Red // Shadows - short up 
#property indicator_color6 FireBrick // Shadows - short down
#property indicator_color7 Red // Bodies - short up
#property indicator_color8 FireBrick // Bodies - short down

//---- indicator parameters
extern int Kijun_Sen_Period = 100;
extern int Candle_Shadow_Width = 1;
extern int Candle_Body_Width = 4;

double KS_2 (int i = 0){return(iIchimoku(NULL,0,Kijun_Sen_Period,Kijun_Sen_Period,Kijun_Sen_Period,MODE_KIJUNSEN,i));}

//---- indicator buffers
double Bar1[],Bar2[],Candle1[],Candle2[];
double Bar3[],Bar4[],Candle3[],Candle4[];

int init()
{    
   IndicatorDigits(Digits);
   SetIndexBuffer(0,Bar1);
   SetIndexBuffer(1,Bar2);
   SetIndexBuffer(2,Candle1);
   SetIndexBuffer(3,Candle2);
   SetIndexBuffer(4,Bar3);
   SetIndexBuffer(5,Bar4);
   SetIndexBuffer(6,Candle3);
   SetIndexBuffer(7,Candle4);
   
   SetIndexStyle(0,DRAW_HISTOGRAM,0,Candle_Shadow_Width);
   SetIndexStyle(1,DRAW_HISTOGRAM,0,Candle_Shadow_Width);
   SetIndexStyle(2,DRAW_HISTOGRAM,0,Candle_Body_Width);
   SetIndexStyle(3,DRAW_HISTOGRAM,0,Candle_Body_Width);
   SetIndexStyle(4,DRAW_HISTOGRAM,0,Candle_Shadow_Width);
   SetIndexStyle(5,DRAW_HISTOGRAM,0,Candle_Shadow_Width);
   SetIndexStyle(6,DRAW_HISTOGRAM,0,Candle_Body_Width);
   SetIndexStyle(7,DRAW_HISTOGRAM,0,Candle_Body_Width);
   
   SetIndexLabel(0,"L-Blue High; D-Blue Low");
   SetIndexLabel(1,"L-Blue Low: D-Blue High");
   SetIndexLabel(2,"L & D-Blue Close");
   SetIndexLabel(3,"L & D-Blue Open");
   SetIndexLabel(4,"L-Red High; D-Red Low");
   SetIndexLabel(5,"L-Red Low; D-Red High");
   SetIndexLabel(6,"L & D-Red Close");
   SetIndexLabel(7,"L & D-Red Open");
   
   return(0);
}

void SetCandleColor(int col, int i)
{
   double high,low,bodyHigh,bodyLow;

   bodyHigh = MathMax(Open[i],Close[i]);
   bodyLow = MathMin(Open[i],Close[i]);
   high	 = High[i];
   low	 = Low[i];

   Bar1[i] = low;	Candle1[i] = bodyLow;
   Bar2[i] = low;	Candle2[i] = bodyLow;
   Bar3[i] = low;	Candle3[i] = bodyLow;
   Bar4[i] = low;	Candle4[i] = bodyLow;
 
   switch(col)
   {
   case 1: Bar1[i] = high;	Candle1[i] = bodyHigh;	break;
   case 2: Bar2[i] = high;	Candle2[i] = bodyHigh;	break;
   case 3: Bar3[i] = high;	Candle3[i] = bodyHigh;	break;
   case 4: Bar4[i] = high;	Candle4[i] = bodyHigh;	break;
   }
}

int start()
{ 
   int limit;
   int counted_bars=IndicatorCounted();
   //---- check for possible errors
   if(counted_bars<0) return(-1);
   //---- the last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
   //---- main loop
   for(int i=0; i<limit; i++)
   {     
      double Ks2	= KS_2(i);

      if(Close[i] > Ks2)	
      {
         if(Open[i] > Close[i])
         {
            SetCandleColor(2,i);
         }
         else if (Open[i] < Close[i])
         {
            SetCandleColor(1,i);
         }   
      }   
      else if(Close[i] < Ks2)	
      {
         if(Open[i] > Close[i])
         {
            SetCandleColor(4,i);
         }
         else if (Open[i] < Close[i])
         { 
            SetCandleColor(3,i);
         }  
      }
   }
   return(0);
}


